org.codehaus.plexus.compiler

## Class AbstractCompiler

- java.lang.Object
- - org.codehaus.plexus.logging.AbstractLogEnabled
  - - org.codehaus.plexus.compiler.AbstractCompiler

- All Implemented Interfaces:
    Compiler, org.codehaus.plexus.logging.LogEnabled
  Direct Known Subclasses:
    CSharpCompiler, EclipseJavaCompiler, JavacCompiler, JikesCompiler

      public abstract class AbstractCompiler
      extends org.codehaus.plexus.logging.AbstractLogEnabled
      implements Compiler

  Author:
    Jason van Zyl , Michal Maczka , Trygve Laugstøl

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static String` | `EOL`
    `protected static String` | `PS`

    - ### Fields inherited from interface org.codehaus.plexus.compiler.Compiler

      `ROLE`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `AbstractCompiler(CompilerOutputStyle compilerOutputStyle, String inputFileEnding, String outputFileEnding, String outputFile)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canUpdateTarget(CompilerConfiguration configuration)`
    `List<CompilerError>` | `compile(CompilerConfiguration configuration)` Deprecated.
    `CompilerOutputStyle` | `getCompilerOutputStyle()`
    `String` | `getInputFileEnding(CompilerConfiguration configuration)`
    `String` | `getOutputFile(CompilerConfiguration configuration)`
    `String` | `getOutputFileEnding(CompilerConfiguration configuration)`
    `static String` | `getPathString(List<String> pathElements)`
    `protected static String[]` | `getSourceFiles(CompilerConfiguration config)`
    `protected static Set<String>` | `getSourceFilesForSourceRoot(CompilerConfiguration config, String sourceLocation)`
    `protected static String` | `makeClassName(String fileName, String sourceDir)`
    `CompilerResult` | `performCompile(CompilerConfiguration configuration)` Performs the compilation of the project.
    `protected static String[]` | `toStringArray(List<String> arguments)` Deprecated. use (String[]) arguments.toArray( new String[ arguments.size() ] ); instead

    - ### Methods inherited from class org.codehaus.plexus.logging.AbstractLogEnabled

      `enableLogging, getLogger, setupLogger, setupLogger, setupLogger`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.codehaus.plexus.compiler.Compiler

      `createCommandLine`

- - ### Field Detail

    - #### EOL

          protected static final String EOL

    - #### PS

          protected static final String PS

  - ### Constructor Detail

    - #### AbstractCompiler

          protected AbstractCompiler(CompilerOutputStyle compilerOutputStyle,
                          String inputFileEnding,
                          String outputFileEnding,
                          String outputFile)

  - ### Method Detail

    - #### performCompile

          public CompilerResult performCompile(CompilerConfiguration configuration)
                                        throws CompilerException

      Description copied from interface: `Compiler`
      Performs the compilation of the project. Clients must implement this method.
      Specified by:
        `performCompile` in interface `Compiler`
      Parameters:
        `configuration` - the configuration description of the compilation to perform
      Returns:
        the result of the compilation returned by the language processor
      Throws:
        `CompilerException`

    - #### compile

          @Deprecated
          public List<CompilerError> compile(CompilerConfiguration configuration)
                                      throws CompilerException

      Deprecated.
      Description copied from interface: `Compiler`
      This method is provided for backwards compatibility only. Clients should use `Compiler.performCompile(CompilerConfiguration)` instead.
      Specified by:
        `compile` in interface `Compiler`
      Parameters:
        `configuration` - the configuration description of the compilation to perform
      Returns:
        the result of the compilation returned by the language processor
      Throws:
        `CompilerException`

    - #### getCompilerOutputStyle

          public CompilerOutputStyle getCompilerOutputStyle()

      Specified by:
        `getCompilerOutputStyle` in interface `Compiler`

    - #### getInputFileEnding

          public String getInputFileEnding(CompilerConfiguration configuration)
                                    throws CompilerException

      Specified by:
        `getInputFileEnding` in interface `Compiler`
      Throws:
        `CompilerException`

    - #### getOutputFileEnding

          public String getOutputFileEnding(CompilerConfiguration configuration)
                                     throws CompilerException

      Specified by:
        `getOutputFileEnding` in interface `Compiler`
      Throws:
        `CompilerException`

    - #### getOutputFile

          public String getOutputFile(CompilerConfiguration configuration)
                               throws CompilerException

      Specified by:
        `getOutputFile` in interface `Compiler`
      Throws:
        `CompilerException`

    - #### canUpdateTarget

          public boolean canUpdateTarget(CompilerConfiguration configuration)
                                  throws CompilerException

      Specified by:
        `canUpdateTarget` in interface `Compiler`
      Throws:
        `CompilerException`

    - #### getPathString

          public static String getPathString(List<String> pathElements)

    - #### getSourceFilesForSourceRoot

          protected static Set<String> getSourceFilesForSourceRoot(CompilerConfiguration config,
                                                String sourceLocation)

    - #### getSourceFiles

          protected static String[] getSourceFiles(CompilerConfiguration config)

    - #### makeClassName

          protected static String makeClassName(String fileName,
                             String sourceDir)
                                         throws CompilerException

      Throws:
        `CompilerException`

    - #### toStringArray

          protected static String[] toStringArray(List<String> arguments)

      Deprecated. use (String[]) arguments.toArray( new String[ arguments.size() ] ); instead

Copyright © 2015. All rights reserved.